
//Zkryhn

using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using UnityEngine;
using System.Linq;
namespace Mod
{
    public class Mod : MonoBehaviour
    {
        public static Map[] Maps;
        public static Map Vol;
        public static Sprite TemplateSprite = ModAPI.LoadSprite("TEMPLATE.png");
        public static string mapname;
        public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
        public static bool debounce = false;
        public static Sprite Square = ModAPI.LoadSprite("black.png");
        public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
        public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
        public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
        public static bool Done = false;
        public static string MapModName = "";
        public static string MapName = "SDV2";
        public static Sprite CustomSprite1 = ModAPI.LoadSprite("CustomSprite1.png");
        public static Sprite CustomSprite2 = ModAPI.LoadSprite("CustomSprite2.png");
        public static Sprite CustomSprite3 = ModAPI.LoadSprite("CustomSprite3.png");
        public static Sprite CustomSprite6 = ModAPI.LoadSprite("CustomSprite6.png");
        public static Sprite CustomSprite7 = ModAPI.LoadSprite("CustomSprite7.png");


        public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

        public static void OnLoad()
        {
            phys.Brittleness = 0f;
            phys.Buoyancy = 0f;
            phys.Flammability = 0f;
            phys.MagneticAttractionIntensity = 0f;
            phys.Conducting = false;
            phys.Burnrate = 0f;
            phys.ImpactIntensityMutliplier = 1f;
            phys.HitVolumeMultiplier = 1f;
            phys.BulletSpeedAbsorptionPower = 0f;
            phys.Softness = 0.1f;
            phys.LodgeStrengthMultiplier = 0.1f;
            phys.SharpForceThresholdMultiplier = 1f;
            // 
            Map MapMod = ScriptableObject.CreateInstance<Map>();
            MapMod.name = MapName;
            MapMod.UniqueIdentity = Guid.NewGuid().ToString();
            MapMod.Description = "Map";
            MapMod.Thumbnail = ModAPI.LoadSprite("TEMPLATE.png");
            MapMod.Preview = ModAPI.LoadSprite("TEMPLATE.png");
            MapMod.Prefab = MapRegistry.GetAllMaps().ElementAt(2).Prefab;
            MapModName = MapMod.name;
            MapRegistry.Register(MapMod);
        }

        public static void RemoveBorders()
        {
            foreach (var render in GameObject.Find("Root").transform.parent.GetComponentsInChildren<SpriteRenderer>())
            {
                if (render.gameObject.layer == LayerMask.NameToLayer("Bounds") && render.gameObject.GetComponent<Undraggable>())
                {
                    Destroy(render.gameObject);
                }
            }

            Map eggs = Resources.Load<Map>("Maps/Humongous");
            foreach (MapLightBehaviour light in UnityEngine.Object.FindObjectsOfType<MapLightBehaviour>())
            {
                Destroy(light.gameObject);
            }
            var thing = Instantiate<GameObject>(eggs.Prefab.transform.Find("Lightbulb/BulbGlow/full ambient").gameObject);
            thing.transform.position = new Vector2(500f, 100f);
            thing.transform.localScale = new Vector2(100000f, 100000f);
            thing.GetComponent<SpriteRenderer>().material.SetFloat("_GlowIntensity", 1.2f);
            thing.GetComponent<SpriteRenderer>().material.SetColor("_GlowColour", new Color32(255, 255, 255, 225));
            if (GameObject.Find("Panels"))
            {
                GameObject.Find("Panels").transform.localScale = new Vector2(100000f, 100000f);
            }
            MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
            mapconfig.GetComponent<BoundingBoxBehaviour>().BoundingBox = new Bounds(new Vector3(500f, 250f, 0f), new Vector3(1500000f, 1500000f, 0f));
        }

        public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision, int Order = 0)
        {
            var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
            NewGameobject.tag = "NoClear";
            NewGameobject.layer = LayerMask.NameToLayer("Bounds");
            NewGameobject.transform.localScale = Size;
            NewGameobject.transform.position = Pos;
            if (Layer == "Front")
            {
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
            }
            if (Layer == "Back")
            {
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
            }
            if (Layer == "Bottom")
            {
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
            }
            NewGameobject.transform.rotation = Rotation;
            if (NoCollision)
            {
                NewGameobject.GetComponent<Collider2D>().enabled = false;
            }
            NewGameobject.transform.parent = null;
            NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
            NewGameobject.AddComponent<Undraggable>();
            NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
            NewGameobject.AddComponent<ContextMenuOptionComponent>();
            PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
            physicalBehaviour.Properties = Mod.phys;
            physicalBehaviour.SpawnSpawnParticles = false;
            physicalBehaviour.OverrideShotSounds = new AudioClip[0];
            physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
            physicalBehaviour.Deletable = false;
            physicalBehaviour.Disintegratable = false;
            physicalBehaviour.Deletable = false;
            physicalBehaviour.Disintegratable = false;
            physicalBehaviour.DisplayBloodDecals = false;
            physicalBehaviour.ChargeBurns = false;
            physicalBehaviour.SimulateTemperature = false;
            ///NewGameobject.AddComponent<AudioSource>();
            ///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
            NewGameobject.AddComponent<TestDelay>();
        }

        public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int Order = 0)
        {
            var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
            NewGameobject.tag = "NoClear";
            NewGameobject.layer = LayerMask.NameToLayer("Bounds");
            NewGameobject.transform.position = Pos;
            NewGameobject.transform.localScale = Size;
            NewGameobject.transform.rotation = Rotation;
            NewGameobject.FixColliders();
            if (Layer == "Front")
            {
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
            }
            if (Layer == "Back")
            {
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
            }
            if (NoCollision)
            {
                foreach (var col in NewGameobject.GetComponents<Collider2D>())
                {
                    col.enabled = false;
                }
            }
            NewGameobject.transform.parent = null;
            NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
            NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
            NewGameobject.AddComponent<Undraggable>();
            NewGameobject.AddComponent<ContextMenuOptionComponent>();
            PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
            physicalBehaviour.Properties = Mod.phys;
            physicalBehaviour.SpawnSpawnParticles = false;
            physicalBehaviour.OverrideShotSounds = new AudioClip[0];
            physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
            physicalBehaviour.Deletable = false;
            physicalBehaviour.Disintegratable = false;
            physicalBehaviour.Deletable = false;
            physicalBehaviour.Disintegratable = false;
            physicalBehaviour.DisplayBloodDecals = false;
            physicalBehaviour.ChargeBurns = false;
            physicalBehaviour.SimulateTemperature = false;
            physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
            ///NewGameobject.AddComponent<AudioSource>();
            ///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
            NewGameobject.AddComponent<TestDelay>();
        }

        public static void CreateSpawnable(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, bool FacingRight, bool Frozen)
        {
            GameObject NewGameobject = Instantiate<GameObject>(ModAPI.FindSpawnable(Name).Prefab, Vector3.zero, Quaternion.identity);
            NewGameobject.transform.position = Pos;
            NewGameobject.transform.localScale = Size;
            NewGameobject.transform.rotation = Rotation;
            if (!FacingRight)
            {
                NewGameobject.transform.localScale = new Vector2(-NewGameobject.transform.localScale.x, NewGameobject.transform.localScale.y);
            }
            if (Frozen)
            {
                NewGameobject.AddComponent<TestDelay>();
            }
        }

        public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
        {
            var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
            if (Layer == "Front")
            {
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
            }
            if (Layer == "Back")
            {
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
            }
            NewGameobject.tag = "NoClear";
            NewGameobject.transform.position = Pos;
            NewGameobject.transform.localScale = Size;
            NewGameobject.transform.rotation = Rotation;
            NewGameobject.FixColliders();
            PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
            if (NoCollision)
            {
                NewGameobject.GetComponent<Collider2D>().enabled = false;
            }
            physicalBehaviour.OverrideShotSounds = new AudioClip[0];
            physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
        }

        public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
        {
            var NewGameobject = new GameObject();
            NewGameobject.tag = "NoClear";
            NewGameobject.transform.position = Pos;
            NewGameobject.transform.localScale = Size;
            NewGameobject.transform.rotation = Rotation;
            var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness);
            light.gameObject.tag = "NoClear";
        }

        public static void CreateBackground(String Name, Color32 color, Sprite spritey, bool IsTexture)
        {
            var NewGameobject = new GameObject();
            NewGameobject.tag = "NoClear";
            NewGameobject.transform.position = new Vector2(572.314f, 496.2918f);
            var whitespace = Texture2D.whiteTexture;
            whitespace.Resize(16, 16);
            whitespace.Apply();
            if (IsTexture == true)
            {
                var croppedTexture = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
                var pixels = spritey.texture.GetPixels((int)spritey.textureRect.x,
                                                        (int)spritey.textureRect.y,
                                                        (int)spritey.textureRect.width,
                                                        (int)spritey.textureRect.height);
                croppedTexture.SetPixels(pixels);
                croppedTexture.wrapMode = TextureWrapMode.Repeat;
                croppedTexture.filterMode = FilterMode.Point;
                croppedTexture.Apply();
                var copy = Sprite.Create(croppedTexture, new Rect(0f, 0f, (float)croppedTexture.width, (float)croppedTexture.height), 0.5f * Vector2.one, 140f, 0, SpriteMeshType.FullRect);
                NewGameobject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
                NewGameobject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
                NewGameobject.GetComponent<SpriteRenderer>().sprite = copy;
                NewGameobject.GetComponent<SpriteRenderer>().size = new Vector2(5, 5);
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
                ///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
            }
            else
            {
                NewGameobject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whitespace, new Rect(0f, 0f, 16f, 16f), 0.5f * Vector2.one, 35f);
                NewGameobject.GetComponent<SpriteRenderer>().color = color;
                NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
                ///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
            }
            NewGameobject.transform.localScale = new Vector2(2533.112f, 2175.462f);
            NewGameobject.transform.parent = null;
            NewGameobject.layer = LayerMask.NameToLayer("Bounds");
        }

        public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
        {
            var NewGameobject = new GameObject();
            NewGameobject.tag = "NoClear";
            NewGameobject.name = Name;
            NewGameobject.transform.position = Pos;
            NewGameobject.AddComponent<ParticleDelay>();
            NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
            NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
        }

        public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
        {
            ///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
            MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
            ///mapconfig.OverrideAmbientSounds = true;
            var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
            hhh.Clips = Eggs;
            hhh.ChancePerSecond = Bacon;
        }

        public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
        {
            switch (Type)
            {
                case "Water":
                    {
                        Map sea = Resources.Load<Map>("Maps/Sea");
                        GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
                        var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
                        Water.transform.rotation = Rotation;
                        Water.transform.localScale = new Vector2(Size.x, -Size.y);
                        Water.transform.localPosition = Pos;
                        break;
                    }
                case "Acid":
                    {
                        Map sea = Resources.Load<Map>("Maps/Sea");
                        GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
                        var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
                        Water.transform.rotation = Rotation;
                        Water.transform.localScale = new Vector2(Size.x, -Size.y);
                        Water.transform.localPosition = Pos;
                        Water.name = "Acid";
                        Water.AddComponent<AcidWater>();
                        break;
                    }
                case "Lava":
                    {
                        Map lavaMap = Resources.Load<Map>("Maps/Lava");
                        GameObject LavaBefore = lavaMap.Prefab.transform.Find("Lava pool").gameObject;
                        var Lava = Instantiate<GameObject>(LavaBefore, Vector3.zero, Quaternion.identity);
                        Lava.transform.rotation = Rotation;
                        Lava.transform.localScale = new Vector2(Size.x, -Size.y);
                        Lava.transform.localPosition = Pos;
                        break;
                    }
            }
        }

        public static void Main()
        {
            ///Don't do anything yet.
            if (MapLoaderBehaviour.CurrentMap.name == MapModName)
            {
                Debug.Log("Setting up some stuff.");
                var manager = new GameObject("managerMap");
                manager.AddComponent<MapModManager>();
            }
        }
        public static void InitilizeMap()
        {
            foreach (var waterBlock in GameObject.FindObjectsOfType<WaterBehaviour>())
            {
                GameObject.Destroy(waterBlock.gameObject);
            }
            foreach (var waterBlock in GameObject.FindObjectsOfType<LavaBehaviour>())
            {
                GameObject.Destroy(waterBlock.gameObject);
            }

            CreateCustomGameObjects("Custom", new Vector2(114f, 33f), new Vector2(-4f, 6f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
            CreateCustomGameObjects("Custom", new Vector2(24.32087f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(354f, 33f), new Vector2(-4f, 6f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
            CreateCustomGameObjects("Custom", new Vector2(594f, 33f), new Vector2(-4f, 6f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
            CreateCustomGameObjects("Custom", new Vector2(834f, 33f), new Vector2(-4f, 6f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
            CreateCustomGameObjects("Custom", new Vector2(1032f, 33f), new Vector2(-4f, 6f), Quaternion.Euler(0f, 0f, 0f), CustomSprite1, "Front", false, 0);
            CreateCustomGameObjects("Custom", new Vector2(84f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(144f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(204f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(264f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(327f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(387f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(447f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(507f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(567f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(627f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(687f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(747f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(807f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(867f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(927f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(987f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(1047f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(1095f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(1120.83f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(429.3021f, 4f), new Vector2(-53269f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite3, "Front", true, 1000);
            CreateCustomGameObjects("Custom", new Vector2(1.847286f, 414.9751f), new Vector2(-53269f, 1f), Quaternion.Euler(0f, 0f, 270f), CustomSprite3, "Front", true, 1000);
            CreateCustomGameObjects("Custom", new Vector2(1145.977f, 495.7335f), new Vector2(-53269f, 1f), Quaternion.Euler(0f, 0f, 90f), CustomSprite3, "Front", true, 1000);
            CreateCustomGameObjects("Custom", new Vector2(690.4886f, 978.9883f), new Vector2(-53269f, 1f), Quaternion.Euler(0f, 0f, 180f), CustomSprite3, "Front", true, 1000);
            CreateCustomGameObjects("Custom", new Vector2(288f, 69f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite2, "Front", true, 1);
            CreateCustomGameObjects("Custom", new Vector2(576.673f, 69.22414f), new Vector2(1f, 1f), Quaternion.Euler(0f, 0f, 0f), CustomSprite7, "Front", false, 0);
            
			SpriteRenderer SPR;
            SPR = new GameObject("Hintergrund").AddComponent<SpriteRenderer>();
			SPR.gameObject.transform.position =new Vector3(565.6798f, 481.7658f,0);
            SPR.gameObject.transform.localScale =new Vector3(-43139f, 139f,1f);
            SPR.sortingLayerName = "Bottom";
            SPR.sortingOrder = -2;
            SPR.sprite = CustomSprite6;
        }
    }
    public class AcidWater : MonoBehaviour
    {
        private void Start()
        {
            SpriteRenderer spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
            spriteRenderer.material.shader = Shader.Find("Sprites/Default");
            spriteRenderer.material.color = new Color(0, 1f, 0.1509f, 0.1819f);
            spriteRenderer.color = new Color(0, 1, 0, 1);
        }
        private void OnTriggerEnter2D(Collider2D collider2D)
        {
            if (collider2D.gameObject.GetComponent<LimbBehaviour>() != null)
            {
                collider2D.gameObject.AddComponent<AcidEffect>();
            }
        }
        private void OnTriggerExit2D(Collider2D collider2D)
        {
            if (collider2D.gameObject.GetComponent<AcidEffect>() != null)
            {
                UnityEngine.Object.Destroy(collider2D.gameObject.GetComponent<AcidEffect>());
            }
        }

    }
    public class AcidEffect : MonoBehaviour
    {
        LimbBehaviour limbBehaviour;
        private void Start()
        {
            limbBehaviour = gameObject.GetComponent<LimbBehaviour>();
        }
        private void Update()
        {
            limbBehaviour.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 0.05f * Time.deltaTime);
        }
    }
    public class MapModManager : MonoBehaviour
    {
        private void Start()
        {
            Mod.InitilizeMap();
        }
    }

    public class TestDelay : MonoBehaviour
    {
        public void Awake()
        {
            StartCoroutine(Delay());
        }

        public IEnumerator Delay()
        {
            yield return new WaitForSeconds(0f);
            foreach (var Rig in this.gameObject.GetComponentsInChildren<Rigidbody2D>())
            {
                Rig.bodyType = RigidbodyType2D.Static;
            }
        }
    }

    public class ParticleDelay : MonoBehaviour
    {
        public string Particles1;
        public float Speed1;
        public void Awake()
        {
            StartCoroutine(Emit());
        }

        public IEnumerator Emit()
        {
            yield return new WaitForSeconds(0.25f);
            while (true)
            {
                var time = 1f / Speed1;
                ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
                yield return new WaitForSeconds(time);
            }
        }
    }
}

